#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Tue Apr  3 14:51:32 2018

@author: Aishwarya Selvaraj
"""
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

from AndorCameraDriver import andorCameraSDK3 as andorCamera
from matplotlib import pyplot as plt
from atexit import register
from matplotlib import cm
import numpy as np
import time
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

import Tkinter as tk
import ttk
from Tkinter import *
#from Tkinter import Tk, Label, Button,Menubutton,Menu,OptionMenu,Checkbutton, S,W,N
import tkMessageBox
from PIL import Image, ImageTk
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg,NavigationToolbar2TkAgg
from matplotlib.figure import Figure
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
from threading import Thread


#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
class AndorCameraGUI(andorCamera):
	def __init__(self, master):
		self.master = master
		master.title("Andor SDK Software with Cython")

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		#Initilaising all the parameters required in the code.
		self.width = 0
		self.height = 0
		self.stride = 0
		self.HBin = 0
		self.VBin = 0
		self.leftPixel = 0
		self.topPixel = 0
		self.framecount = 0

		self.camera = 0
		self.currentTemperature =0
		self.image_height = 0
		self.image_width = 0

		self.count1 = 0 # To know is preamp gain is chosen or not;if count1 ==0 then default is chosen ; else the respective option is choosen
		self.count2 = 0 # TO know if Shutter mode is chosen or not
		self.count3 = 0 # To know if image area is selected or not;if count3 ==0 then set_default ;count3 = 1 the option is selected
		self.count4 = 0 # To know if binning is selected or not;if count3 ==0 then set_default ;count3 = 1 the option is selected
		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.label = Label(master, text = "Andor NEO Camera", relief = RAISED, font = ("times Bold", 15))
		self.label.place(relx = 0.38, rely = 0)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.camera_string = Button(master, text = "Select Camera", relief = RAISED, font = ("times Bold", 10),
									command = self.getCameraStringGUI)
		self.camera_string.place(relx = 0.05, rely = 0.1, height = 22, width = 120)
		self.camera_string_value = Label(master, relief = 'sunken', bg = 'white')
		self.camera_string_value.place(relx = 0.2, rely = 0.1, height = 22, width = 200)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.exposure_time = Label(master, text = "Exposure Time", relief = FLAT, font = ("times Bold", 10))
		self.exposure_time.place(relx = 0.54, rely = 0.1, height = 22, width = 100)
		self.default_exp_time = 0.01
		self.v1 = StringVar()
		self.v1.set(self.default_exp_time)
		self.exposure_time_value = Entry(master,textvariable = self.v1)
		self.exposure_time_value.place(relx = 0.72, rely = 0.1, height = 27, width = 100)
		self.exposure_time_value.bind('<Leave>', self.set_ExposureTimeGUI)
		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.no_of_frames = Label(master, text = "Number of Acquisitions", relief = FLAT, font = ("times Bold", 10))
		self.no_of_frames.place(relx = 0.54, rely = 0.15)
		self.no_of_frames_default= 100
		self.v = StringVar()
		self.v.set(self.no_of_frames_default)  # default choice
		self.no_of_frames_value = Entry(master,textvariable = self.v)
		self.no_of_frames_value.place(relx = 0.72, rely = 0.15, height = 27, width = 100)
		self.no_of_frames_value.bind('<Leave>', self.set_FrameCountGUI)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#

		self.pixel_readout = Label(master, text = "Pixel Readout Rate", relief = FLAT, font = ("times Bold", 10))
		self.pixel_readout.place(relx = 0.54, rely = 0.20, height = 22, width = 125)
		self.pixel_readout_optionList = ["280 MHz", "200 MHz", "100 MHz"]
		self.pixel_readout_options = StringVar()
		self.pixel_readout_options.set(self.pixel_readout_optionList[0])  # default choice
		self.dropMenu1 = OptionMenu(master, self.pixel_readout_options, *self.pixel_readout_optionList,
									command = self.set_PixelReadoutRateGUI)
		self.dropMenu1.place(relx = 0.72, rely = 0.2, height = 27, width = 100)

		# self.pixel_readout = Menubutton(master,text = "Pixel Readout Rate",relief=RAISED,font=("times Bold", 10))
		# self.pixel_readout.place(relx = 0.7, rely = 0.20)
		# self.pixel_readout_options = Menu(self.pixel_readout, tearoff=0 )
		# self.pixel_readout['menu'] = self.pixel_readout_options
		# self.pixel_readout_options.add_command(label="Houston", command=self.on_menu_item_clicked)
		# self.pixel_readout_options.add_command(label="Seattle", command=self.on_menu_item_clicked)

		# menubutton = Tkinter.Menubutton(text="Pixel Readout Rate",relief=RAISED,font=("times Bold", 10))
		# menubutton.place(relx = 0.7, rely = 0.20)
		# menu = Tkinter.Menu(menubutton, tearoff=0)
		# menubutton['menu'] = menu
		# menu.add_command(label="Houston", command=self.on_menu_item_clicked)
		# menu.add_command(label="Seattle", command=self.on_menu_item_clicked)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.PreAmpGain = Label(master, text = "Pre Amp Gain", relief = FLAT, font = ("times Bold", 10))
		self.PreAmpGain.place(relx = 0.54, rely = 0.25)
		self.PreAmpGain_value = Label(master, relief = 'sunken', bg = 'white')
		self.PreAmpGain_value.place(relx = 0.72, rely = 0.25, height = 27, width = 300)
		#optionList = ["11-bit (high well capacity)", "12-bit (high well capacity)", "11-bit (low noise)","12-bit (low noise)", "16-bit (low noise & high well capacity)"]
		#self.PreAmpGain_options = StringVar()
		#self.PreAmpGain_options.set("16-bit (low noise & high well capacity)")  # default choice
		#self.dropMenu2 = OptionMenu(master, self.PreAmpGain_options, *optionList, command = self.set_PreAmpGainGUI)
		#self.dropMenu2.place(relx = 0.72, rely = 0.25)
		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.pixel_encoding = Label(master, text = "Pixel Encoding", relief = FLAT, font = ("times Bold", 10))
		self.pixel_encoding.place(relx = 0.54, rely = 0.30)
		self.pixel_encoding_value = Label(master, relief = 'sunken', bg = 'white')
		self.pixel_encoding_value.place(relx = 0.72, rely = 0.30, height = 27, width = 100)
		#optionList = ["Mono12", "Mono12Packed", "Mono16", "Mono32"]
		#self.pixel_encoding_options = StringVar()
		#self.pixel_encoding_options.set("Mono16")  # default choice
		#self.dropMenu2 = OptionMenu(master, self.pixel_encoding_options, *optionList, command = self.set_PixelEncoding)
		#self.dropMenu2.place(relx = 0.72, rely = 0.30, height = 27, width = 100)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.shutter_mode = Label(master, text = "Shutter Mode", relief = FLAT, font = ("times Bold", 10))
		self.shutter_mode.place(relx = 0.54, rely = 0.35)
		self.shutter_mode_optionList = ["Rolling", "Global"]
		self.shutter_mode_options = StringVar()
		self.shutter_mode_options.set("Rolling")  # default choice
		self.dropMenu2 = OptionMenu(master, self.shutter_mode_options, *self.shutter_mode_optionList, command = self.set_ShutterModeGUI)
		self.dropMenu2.place(relx = 0.72, rely = 0.35, height = 27, width = 100)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.trigger_mode = Label(master, text = "Trigger Mode", relief = FLAT, font = ("times Bold", 10))
		self.trigger_mode.place(relx = 0.54, rely = 0.40)
		self.trigger_mode_value = Label(master, relief = 'sunken', bg = 'white')
		self.trigger_mode_value.place(relx = 0.72, rely = 0.40, height = 27, width = 100)

		#optionList = ["Internal", "Software", "External", "External Start", "External Exposure"]
		#self.trigger_mode_options = StringVar()
		#self.trigger_mode_options.set("Internal")  # default choice
		#self.dropMenu4 = OptionMenu(master, self.trigger_mode_options, *optionList, command = self.set_TriggerMode)
		#self.dropMenu4.place(relx = 0.72, rely = 0.40, height = 27, width = 100)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.frame_rate = Label(master, text = "Frame Rate", relief = FLAT, font = ("times Bold", 10))
		self.frame_rate.place(relx = 0.54, rely = 0.45)
		self.frame_rate_value = Label(master, bg = 'white')
		self.frame_rate_value.place(relx = 0.72, rely = 0.45, height = 27, width = 100)
		# self.frame_rate_value.bind('<Leave>', self.set_FrameRate)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.label = Label(master, text = "Binning/ROI", relief = RAISED, font = ("times Bold ", 12))
		self.label.place(relx = 0.54, rely = 0.50, height = 24, width = 400)

		self.image_area = Label(master, text = "Image Area", relief = FLAT, font = ("times Bold", 10))
		self.image_area.place(relx = 0.512, rely = 0.55, height = 22, width = 120)
		optionList = ["2560 x 2160", "2048 x 2048", "1920 x 1080", "1392 x 1040", "512 x 512", "128 x 128"]
		self.image_area_options = StringVar()
		self.image_area_options.set("512 x 512")  # default choice
		self.dropMenu3 = OptionMenu(master, self.image_area_options, *optionList, command = self.set_ImageArea)
		self.dropMenu3.place(relx = 0.72, rely = 0.55, height = 27, width = 100)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#

		self.pixel_binning = Label(master, text = "Pixel Binning", relief = FLAT, font = ("times Bold", 10))
		self.pixel_binning.place(relx = 0.512, rely = 0.60, height = 22, width = 120)
		optionList = ["1 x 1", "2 x 2", "3 x 3", "4 x 4", "8 x 8"]
		self.pixel_binning_options = StringVar()
		self.pixel_binning_options.set("1 x 1")  # default choice
		self.dropMenu4 = OptionMenu(master, self.pixel_binning_options, *optionList, command = self.set_PixelBinning)
		self.dropMenu4.place(relx = 0.72, rely = 0.60, height = 27, width = 100)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		# self.VerticallyCentreAOI_enable = IntVar()
		# self.VerticallyCentreAOI = Checkbutton(master, text="Auto Vertical Center",font=("times Bold", 10), variable=self.VerticallyCentreAOI_enable)
		# self.VerticallyCentreAOI.place(relx = 0.54, rely = 0.65)
		# self.VerticallyCentreAOI.bind('<Leave>', self.set_Enable)

		self.VerticallyCentreAOI_enable = IntVar()
		self.VerticallyCentreAOI = Checkbutton(master, variable = self.VerticallyCentreAOI_enable)
		self.label = Label(master, text = "Auto Vertical Center", font = ("times Bold", 10))
		self.label.place(relx = 0.525, rely = 0.65)
		self.VerticallyCentreAOI.place(relx = 0.72, rely = 0.65)
		self.VerticallyCentreAOI.bind('<Leave>', self.EnableVerticallyAOI)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#

		self.height = Label(master, text = "Height", relief = FLAT, font = ("times Bold", 10))
		self.height.place(relx = 0.501, rely = 0.70, height = 22, width = 100)
		self.height_value = Entry(master)
		self.height_value.place(relx = 0.72, rely = 0.70, height = 27, width = 100)
		self.height_value.insert(0, 512)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#

		self.width = Label(master, text = "Width", relief = FLAT, font = ("times Bold", 10))
		self.width.place(relx = 0.501, rely = 0.75, height = 22, width = 100)
		self.width_value = Entry(master)
		self.width_value.place(relx = 0.72, rely = 0.75, height = 27, width = 100)
		self.width_value.insert(0, 512)
		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.top = Label(master, text = "Top", relief = FLAT, font = ("times Bold", 10))
		self.top.place(relx = 0.535, rely = 0.80)
		self.top_value = Entry(master)
		self.top_value.insert(0, 1)
		self.top_value.place(relx = 0.72, rely = 0.80, height = 27, width = 100)
		self.top_value.bind('<Leave>', self.set_Top)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.left = Label(master, text = "Left", relief = FLAT, font = ("times Bold", 10))
		self.left.place(relx = 0.535, rely = 0.85)
		self.left_value = Entry(master)
		self.left_value.insert(0, 1)
		self.left_value.place(relx = 0.72, rely = 0.85, height = 27, width = 100)
		self.left_value.bind('<Leave>', self.set_Left)
		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#

		self.single_acquisition = Button(master, text = "Single Scan", relief = RAISED, font = ("times Bold", 10),
										 command = self.acquireImageGUI)
		self.single_acquisition.place(relx = 0.05, rely = 0.85)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.live_acquisition = Button(master, text = "Live Mode", relief = RAISED, font = ("times Bold", 10),
									   command = self.LiveAquisitionGUI)
		self.live_acquisition.place(relx = 0.205, rely = 0.85)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		self.stop = Button(master, text = "STOP", relief = RAISED, font = ("times Bold", 10), command = self.Stop)
		self.stop.place(relx = 0.34, rely = 0.85)

		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
		# self.temperature = Button(master, text = "Temperature",relief=RAISED,font=("times Bold", 10),command=self.get_Temperature)
		# self.temperature.place(relx = 0.535, rely = 0.90)
		self.temperature_value = Label(master, relief = 'sunken', bg = "red", fg = "white")
		self.temperature_value.place(relx = 0.72, rely = 0.90, height = 27, width = 200)
		# self.temperature_value = Entry(master)
		# self.temperature_value.place(relx = 0.72, rely = 0.90,height = 22, width = 50)
		# self.temperature_value.bind('<Leave>', self.get_Temperature)

		self.btnMenu = Menubutton(master, text = 'Temperature', relief = RAISED, font = ("times Bold", 10))
		self.contentMenu = Menu(self.btnMenu)
		self.btnMenu.config(menu = self.contentMenu)
		self.btnMenu.place(relx = 0.535, rely = 0.90)

		btnList = ['-15', '-20', '-25', '-30', '-35', '-40']
		for btn in btnList:
			self.contentMenu.add_command(label = btn, command = lambda btn = btn: self.set_Temperature(btn))
		# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#


	# -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
	def convert2String(self,charlist):
		string = ""
		for c in charlist:
			try:
				if c != 0:
					string += chr(c)
			except:
				pass  # print c
		return string

	def getCameraStringGUI(self):
		self.camera_string.destroy()
		camera_selected = Button(self.master, text = "Camera Connected")
		camera_selected.place(relx = 0.05, rely = 0.1, height = 22, width = 120)
		andorCamera.initializeCameraLibrary()
		self.camera = andorCamera(self)
		cameraString = self.camera.getCameraString()
		camera_name =  self.convert2String(cameraString)
		self.camera_string_value.config(text = str(camera_name))
		print "--------------------------------------------------------------------------------------\n"
		preampgain_name =  self.camera.set_PreAmpGain()
		preampgain = self.convert2String(preampgain_name)
		self.PreAmpGain_value.config(text =str(preampgain) )
		print "--------------------------------------------------------------------------------------\n"
		pixelEncoding_name = self.camera.set_PixelEncoding()
		pixelEncoding = self.convert2String(pixelEncoding_name)
		self.pixel_encoding_value.config(text = str(pixelEncoding))
		print "--------------------------------------------------------------------------------------\n"
		trigger_mode_name = self.camera.set_TriggerMode()
		trigger_mode = self.convert2String(trigger_mode_name)
		self.trigger_mode_value.config(text = str(trigger_mode))
		print "--------------------------------------------------------------------------------------\n"
		self.camera.set_FastAOIFrameRateEnable()



	def set_ExposureTimeGUI(self, event):
		print "--------------------------------------------------------------------------------------\n"
		#camera = andorCamera()
		var = self.exposure_time_value.get()
		if var =='':
			set_exp_val = self.default_exp_time
		else:
			set_exp_val = self.exposure_time_value.get()

		self.camera.set_ExposureTime(float(set_exp_val))
		exposuretime = self.camera.get_ActualExposureTime()
		self.exposure_time_value.delete(0, END)
		self.exposure_time_value.insert(0, exposuretime)





	def set_FrameCountGUI(self, event):
		print "--------------------------------------------------------------------------------------\n"
		var = self.no_of_frames_value.get()
		if var =='':
			self.framecount = self.no_of_frames_default
		else:
			self.framecount = self.no_of_frames_value.get()
		accumulatecount = 1

		#camera = andorCamera()
		self.camera.set_FrameCount((accumulatecount),int(self.framecount))



	def set_PixelReadoutRateGUI(self, value):
		print "--------------------------------------------------------------------------------------\n"
		#camera = andorCamera()
		self.camera.set_PixelReadoutRate(value)
		pixelreadoutrate = self.camera.get_PixelReadoutRate()
		self.count1 = 1


	def set_ShutterModeGUI(self, value):
		print "--------------------------------------------------------------------------------------\n"
		#camera = andorCamera()
		shutter_mode_name = self.camera.set_ShutterMode(value)
		shutter_mode = self.convert2String(shutter_mode_name)
		self.count2 = 1




	def set_ImageArea(self, value):
		def get_dimensions(value):
			dimension = value.split("x")
			height = int(dimension[1])
			width = int(dimension[0])
			self.height_value.delete(0, END)
			self.height_value.insert(0, height)
			self.width_value.delete(0, END)
			self.width_value.insert(0, width)
			return height, width


		height, width = get_dimensions(value)
		#print "getdimensions set_imagearea"
		#print (height, width)
		#camera = andorCamera()
		height, width = self.camera.set_HeightWidth(height, width)
		#print "inside set_HeightWidth"
		#print (height, width)
		self.height = height
		self.width = width
		self.count3 = 1



	def set_PixelBinning(self, value):
		#print "The Binning is set to :",
		#print value

		def get_PixelBinning(value):
			binning = value.split("x")
			HBin = int(binning[0])
			VBin = int(binning[1])
			return HBin, VBin

		HBin, VBin = get_PixelBinning(value)
		self.HBin = HBin
		self.VBin = VBin
		self.count4 = 1

	def set_Top(self, event):
		val = self.top_value.get()
		if val == '':
			self.topPixel = 1
		else:
			self.topPixel = self.top_value.get()



	def set_Left(self, event):
		val = self.left_value.get()
		if val =='':
			self.leftPixel = 1
		else:
			self.leftPixel = self.left_value.get()


	def set_AOIGUI(self):
		# This is the code that would have the set_AOI code bt check how you want the sucess messages to appear in it.
		#camera = andorCamera()
		sensorDetails = self.camera.get_SensorDetails()

		self.image_width = sensorDetails[2]
		self.image_height = sensorDetails[3]
		self.stride = sensorDetails[4]
		#print "inside get_sensordetails:",
		#print (self.image_height,self.image_width)

		#HBin, VBin, leftPixel, width, topPixel, height = self.HBin, self.VBin, self.leftPixel, self.image_height, self.topPixel, self.image_height
		#print ((int(self.HBin), int(self.VBin), int(self.leftPixel), int(self.width), int(self.topPixel), int(self.height)))
		self.camera.set_AOI((int(self.HBin), int(self.VBin), int(self.leftPixel), int(self.width), int(self.topPixel), int(self.height)))


	def EnableVerticallyAOI(self, event):
		val = self.VerticallyCentreAOI_enable.get()
		if val == 0:
			self.top_value.config(state = 'normal')
		else:
			self.top_value.config(state = 'disabled')
			#self.topPixel = 1
		# set_VerticallyCentreAOI() Write this function here :

	def acquireImageGUI(self):
		print "--------------------------------------------------------------------------------------\n"
		self.single_acquisition.configure(relief = tk.SUNKEN, state = tk.DISABLED)
		self.set_default()
		self.DisableAll()
		print "--------------------------------------------------------------------------------------\n"
		self.set_AOIGUI()
		print "--------------------------------------------------------------------------------------\n"
		print "Acquiring Image..."
		I = np.zeros(((int(self.width) - int(self.leftPixel)) / int(self.HBin), (int(self.height) - int(self.topPixel)) / int(self.VBin)), dtype=np.uint16)
		I = np.zeros((int(self.width) / int(self.HBin), int(self.height) / int(self.VBin)), dtype=np.uint16)

		#camera = andorCamera()
		I = self.camera.acquireImage(I)
		self.Plot(I)
		self.single_acquisition.configure(relief = tk.RAISED, state = tk.ACTIVE)



	def LiveAquisitionGUI(self):
		self.live_acquisition.configure(relief = tk.SUNKEN, state = tk.DISABLED)
		print "--------------------------------------------------------------------------------------\n"
		self.set_default()
		frame_rate = self.camera.get_FrameRate()
		self.frame_rate_value.config(text = int(frame_rate))
		self.DisableAll()
		print "--------------------------------------------------------------------------------------\n"
		self.set_AOIGUI()
		print "--------------------------------------------------------------------------------------\n"
		print "In Live Mode..."
		image = np.zeros((5,(int(self.width) - int(self.leftPixel)) / int(self.HBin), (int(self.height) - int(self.topPixel)) / int(self.VBin)), dtype = np.uint16)
		image = np.zeros((5,int(self.width) / int(self.HBin), int(self.height) / int(self.VBin)), dtype = np.uint16)

		image = self.camera.LiveAquisition(int(self.framecount), image)
		self.LivePlot(image)
		self.live_acquisition.configure(relief = tk.RAISED, state = tk.ACTIVE)
		#self.Plot(image[0])
		self.EnableAll()


	def Stop(self):
		self.live_acquisition.configure(relief = tk.RAISED, state = tk.ACTIVE)
		self.single_acquisition.configure(relief = tk.RAISED, state = tk.ACTIVE)
		print "Stop the aquisition..."
		self.canvas.get_tk_widget().destroy()
		self.toolbar.destroy()
		self.EnableAll()



	def Plot(self,image):
		fig = Figure(figsize = (4, 6))
		fig.patch.set_facecolor('xkcd:light grey') # When this is removed a white color is seen in the background of the figure
		a = fig.add_subplot(111)
		a.set_xlim([0, self.image_width/int(self.HBin)])
		a.set_ylim([0, self.image_height/int(self.VBin)])
		image = image.transpose()
		a.imshow(image,'gray')
		self.canvas = FigureCanvasTkAgg(fig,self.master)
		self.canvas.show()
		self.canvas.get_tk_widget().pack(side =LEFT)
		#self.canvas.get_tk_widget().config(borderwidth = 50,highlightthickness = 0)
		self.toolbar = NavigationToolbar2TkAgg(self.canvas,self.master)
		self.toolbar.update()
		self.canvas._tkcanvas.pack(side = LEFT)# change this to TOP so thee the navigation toolbar on the left down

	def LivePlot(self,image):
		fig = Figure(figsize = (4, 5))
		fig.patch.set_facecolor('xkcd:light grey') # When this is removed a white color is seen in the background of the figure
		a = fig.add_subplot(111)
		a.set_xlim([0, self.image_width/int(self.HBin)])
		a.set_ylim([0, self.image_height/int(self.VBin)])
		image = image.swapaxes(1,2)
		a.imshow(image[0],'gray')
		self.canvas = FigureCanvasTkAgg(fig,self.master)
		self.canvas.draw()
		self.canvas.get_tk_widget().pack(side =LEFT)
		def wrapper():
			for i in range(1,5):
				time.sleep(0.7)
				a.imshow(image[i],'gray')
				self.canvas.draw()
		#self._t = Thread(target = wrapper)
		#self._t = start()
		wrapper()

		self.toolbar = NavigationToolbar2TkAgg(self.canvas,self.master)
		self.toolbar.update()
		self.canvas._tkcanvas.pack(side = LEFT)# change this to TOP so thee the navigation toolbar on the left down





	def set_Temperature(self, btn):
		print "--------------------------------------------------------------------------------------\n"
		#print "Desired Temperature :",
		#print btn
		if btn == '-15':
			temperatureIndex = 0
		elif btn == '-20':
			temperatureIndex = 1
		elif btn == '-25':
			temperatureIndex = 2
		elif btn == '-30':
			temperatureIndex = 3
		elif btn == '-35':
			temperatureIndex = 4
		elif btn == '-40':
			temperatureIndex = 5
		else:
			temperatureIndex = 3

		#camera = andorCamera()
		self.camera.set_CameraTemperature(temperatureIndex)
		self.currentTemperature = self.camera.get_Temperature()
		self.temperature_value.config(text = (self.currentTemperature))
		#print self.currentTemperature
		def ControlTemperature():
			#self.temperature_value.config(text = float(camera.get_Temperature()))
			temperatureStatus = self.camera.get_TemperatureStatus()
			temp = self.camera.get_Temperature()
			#print self.convert2String(temperatureStatus),
			#print temp

			if (self.convert2String(temperatureStatus)!="Stabilised"):
				self.temperature_value.config(text = float(temp))
				self.temperature_value.after(1000,ControlTemperature)

			if(self.convert2String(temperatureStatus)=="Stabilised"):
				self.temperature_value.configure(background = "blue", foreground = "white")

		ControlTemperature()

	def set_default(self):
		#camera = andorCamera()
		#-------------------------To set the default value of exposure rate -------------------------------------------#
		var = self.exposure_time_value.get()
		if var == '':
			set_exp_val = self.default_exp_time
		else:
			set_exp_val = self.exposure_time_value.get()

		self.camera.set_ExposureTime(float(set_exp_val))
		exposuretime = self.camera.get_ActualExposureTime()


		#---------------------------------TO take the default value of number of frames into the framecount function---#
		var = self.no_of_frames_value.get()
		if var =='':
			self.framecount = self.no_of_frames_default
		else:
			self.framecount = self.no_of_frames_value.get()
		#print "new frameccoutn = "
		#print framecount
		accumulatecount = 1
		self.camera.set_FrameCount((accumulatecount),int(self.framecount))

		#--------------If nothing is pressed then by default it would take 280MHz value as pixel readout rate
		if self.count1 == 0:
			#camera = andorCamera()
			self.camera.set_PixelReadoutRate(self.pixel_readout_optionList[0])
			pixelreadoutrate = self.camera.get_PixelReadoutRate()
			#print "new pixel readuot :",
			#print pixelreadoutrate
		#----------If nothing is pressed then by default it would take rolling as the dfault shutter mode
		if self.count2 ==0:
			#camera = andorCamera()
			shutter_mode_name = self.camera.set_ShutterMode(self.shutter_mode_optionList[0])
			shutter_mode = self.convert2String(shutter_mode_name)
			#print "new shutter mode ..."
			#print shutter_mode

		#----------If nothing is pressed in image area then the default image area is set to 512x512
		if self.count3 ==0:
			height, width = self.camera.set_HeightWidth(512, 512)
			self.height = height
			self.width = width

		#-------If nothing is pressed in binning then the default binning is set to be 1x1
		if self.count4 ==0:
			self.HBin = 1
			self.VBin = 1

		#-------If nothing is pressed in left pixel value :
		val = self.left_value.get()
		if val =='':
			self.leftPixel = 1
		else:
			self.leftPixel = self.left_value.get()

		#------If nothing is pressed in Top pixel:
		var = self.VerticallyCentreAOI_enable.get()
		if var ==0:
			val = self.top_value.get()
			if val == '':
				self.topPixel = 1
			else:
				self.topPixel = self.top_value.get()
		else:
			self.topPixel =0







	def DisableAll(self):
		self.exposure_time_value.config(state = 'disabled')
		self.no_of_frames_value.config(state = 'disabled')
		self.dropMenu1.config(state = 'disabled')
		self.PreAmpGain_value.config(state = 'disabled')
		self.pixel_encoding_value.config(state = 'disabled')
		self.dropMenu2.config(state = 'disabled')
		self.trigger_mode_value.config(state = 'disabled')
		self.frame_rate_value.config(state = 'disabled')
		self.dropMenu3.config(state = 'disabled')
		self.dropMenu4.config(state = 'disabled')
		self.VerticallyCentreAOI.config(state = 'disabled')
		self.height_value.config(state = 'disabled')
		self.width_value.config(state = 'disabled')
		self.top_value.config(state = 'disabled')
		self.left_value.config(state = 'disabled')


	def EnableAll(self):
		self.exposure_time_value.config(state = 'normal')
		self.no_of_frames_value.config(state = 'normal')
		self.dropMenu1.config(state = 'normal')
		self.PreAmpGain_value.config(state = 'normal')
		self.pixel_encoding_value.config(state = 'normal')
		self.dropMenu2.config(state = 'normal')
		self.trigger_mode_value.config(state = 'normal')
		self.frame_rate_value.config(state = 'normal')
		self.dropMenu3.config(state = 'normal')
		self.dropMenu4.config(state = 'normal')
		self.VerticallyCentreAOI.config(state = 'normal')
		self.height_value.config(state = 'normal')
		self.width_value.config(state = 'normal')
		val = self.VerticallyCentreAOI_enable.get()
		if val == 0:
			self.top_value.config(state = 'normal')
		else:
			self.top_value.config(state = 'disabled')
		self.left_value.config(state = 'normal')

	#def Test(self):
		#self.test_value = Label(master, relief = 'sunken', bg = 'white')
		#self.test_value.place(relx = 0.535, rely = 0.96, height = 27, width = 300)
		#//////............................................self.test_value.config(text = 4589632)









root = Tk()
style = ttk.Style()
root.geometry("900x900")
my_gui = AndorCameraGUI(root)
root.mainloop()
